use ::{gpu_setres_raw, gp1, set_draw_area, fillvram, gpu_opq_mono_rect};

pub struct Progress {
	current: u32,
	steps: u32,
}
impl Progress {
	#[cfg_attr(not(release), inline(never))]
	pub fn new(steps: u32) -> Progress {
		gpu_setres_raw(1, 0, 0, 0);
		gp1(0x05000000 | (0 << 0) | (0 << 10)); // show from = 0,0
		set_draw_area((0, 0), (320-1, 240-1));

		fillvram(0, 0, 0, 0, 0, 320, 240);

		gpu_opq_mono_rect((255, 255, 255), (8, 120-18), (320-8*2, 18*2));
		gpu_opq_mono_rect((0, 0, 0), (12, 120-14), (320-12*2, 14*2));

		Progress { current: 0, steps: steps }
	}
	#[cfg_attr(not(release), inline(never))]
	pub fn step(&mut self) {
		self.current += 1;
		let w = (self.current * (320-16*2) / self.steps) as u16;
		gpu_opq_mono_rect((255, 255, 255), (16, 120-10), (w, 10*2));
	}
}

