OUTPUT_FORMAT(elf32-tradlittlemips)
OUTPUT_ARCH(mips:3000)
ENTRY(start)

MEMORY {
	/* BIOS takes 64kB? */
	RAM : ORIGIN = 0x80010000, LENGTH = 0x200000
}

SECTIONS {
	.header : { *(.header) } > RAM

	.text : { *(.text .text.*) } > RAM
	.rodata : { *(.rodata .rodata.*) } > RAM
	/* .tdata: thread local data? */
	.data : { *(.data .data.* .tdata .tdata.*) } > RAM
	_gp = . + 0x7FF0;
	.sdata : { *(.sdata .sdata.*) *(.lit4 .lit4.* .lit8 .lit8.*) } > RAM
	. = ALIGN(4);
	__bss_start = .;
	.sbss : { *(.sbss .sbss.*) } > RAM
	.bss : { *(.bss .bss.*) } > RAM
	. = ALIGN(4);
	__bss_end = .;

	/DISCARD/ : { *(.reginfo .MIPS.abiflags .pdr .gnu.attributes .comment) }
}
