# coding: utf-8

# simple VB-ish(SPU) encoder
# only supports no-prediction.

samples = File.binread(ARGV[0]).unpack("s*")
open(ARGV[1], "wb") { |f|
	lastenc = 0
	lastshift = 0
	if !ARGV[2]
		loopfix = false
		loop_start = nil
	else
		loopfix = true
		if ARGV[2].end_with? "!"
			loopfix = false
			ARGV[2] = ARGV[2][0..-2]
		end
		loop_start = ARGV[2].to_i
	end
	# align
	if samples.size % 28 != 0
		npads = 28 - (samples.size % 28)
		if loop_start
			# loop: copy head of loop
			samples += samples[loop_start...(loop_start + npads)]
			loop_start += npads
		else
			# oneshot: copy last sample
			samples += [samples.last] * npads
		end
	end
	if loopfix
		# linear interpolate
		sl = samples[loop_start / 28 * 28]
		28.times { |t|
			i = samples.size - 28 + t
			samples[i] = (samples[i] * (28 - t) + sl * (t + 1)) / 29
		}
	end
	# Oops: loop area size must be %28==0 or clicking noise...
	samples.each_slice(28).each_with_index { |sblk, i|
		sblk.size < 28 and raise "program error: short block"
		#puts sblk.map{|e|"%04x"%([e].pack("s").unpack("S")[0])}.join(" ")
		leftest = sblk.map{|e|e.bit_length}.max
		signeq = sblk.map{|e|e<0}.uniq.size == 1
		#if !signeq
			leftest += 1
		#end
		rsh = [leftest - 4, 0].max
		encs = sblk.map{|e| (e >> rsh) & 0x0F}
		sh = 12 - rsh
		#puts ">>%02X %s" % [sh, encs.map{|e| "%X" % e }.join]
		#puts encs.map{|e| [e << 12].pack("S").unpack("s")[0] >> sh }.map{|e|"%04X"%([e].pack("s").unpack("S")[0])}.join(" ")
		#puts
		# pred<<4|sh, flags
		# flags: loop_end(1) | norepeat(!2) | loop_start(4)
		is_loopstart = !loop_start ? false : (loop_start / 28 == i)
		is_lastblock = samples.size / 28 - 1 == i
		flags = (is_loopstart ? 4 : 0) | (is_lastblock ? (loop_start ? 3 : 5) : 0)
		f.write [(0 << 4) | (sh << 0), flags].pack("CC") + encs.each_slice(2).map{|a,b| (b << 4) | a}.pack("C14")

		lastenc = encs.last
		lastshift = sh
	}
}
